<template>
  <div class="w-full h-full bg-white p-4">
    <p class="font-bold text-lg leading-10 border-b-2">工厂管理</p>
    <el-form class="pt-4" :inline="true" :model="formState">
      <el-form-item label="工厂名称">
        <el-input v-model="formState.factoryName" placeholder="颜色名称" clearable />
      </el-form-item>
      <el-form-item label="工厂编码">
        <el-input v-model="formState.factoryCode" placeholder="颜色编码" clearable />
      </el-form-item>
      <el-form-item>
        <el-button type="default" @click="onReset">重置</el-button>
        <el-button type="primary" @click="onQuery">查询</el-button>
      </el-form-item>
    </el-form>

    <div class="">
      <vxe-toolbar>
        <template #buttons>
          <el-button type="primary" @click="showEdit = true">新增</el-button>
          <el-button type="danger" @click="removeRows">删除</el-button>
        </template>
      </vxe-toolbar>
      <vxe-table
        ref="xTable"
        size="small"
        border
        min-height="460"
        :loading="loading"
        :data="tableData"
      >
        <vxe-column type="checkbox" width="50"></vxe-column>
        <!-- <vxe-column field="factoryId" title="id" width="200"></vxe-column> -->
        <vxe-column field="factoryName" title="工厂名称"></vxe-column>
        <vxe-column field="factoryCode" title="工厂编码" show-overflow></vxe-column>
        <vxe-column field="action" title="操作" width="100">
          <template #default="{ row }">
            <el-button type="primary" text size="small" @click="editRow(row)">修改</el-button>
          </template>
        </vxe-column>
      </vxe-table>

      <vxe-pager
        size="small"
        background
        v-model:current-page="formState.currentPage"
        v-model:page-size="formState.pageSize"
        :total="formState.total"
        @page-change="onQuery"
        :layouts="['PrevPage', 'JumpNumber', 'NextPage', 'Sizes', 'FullJump', 'Total']"
      >
      </vxe-pager>
    </div>

    <vxe-modal v-model="showEdit" title="编辑&保存" destroy-on-close esc-closable @hide="onHide">
      <template #default>
        <el-form ref="formRef" label-width="90px" :model="formEdit" :rules="formRules">
          <el-form-item label="工厂名称" prop="factoryName">
            <el-input v-model="formEdit.factoryName"></el-input>
          </el-form-item>
          <el-form-item label="工厂编码" prop="factoryCode">
            <el-input v-model="formEdit.factoryCode"></el-input>
          </el-form-item>
          <el-form-item>
            <el-button type="primary" @click="onSubmit" :loading="saveLoading">提交</el-button>
            <el-button @click="showEdit = false">取消</el-button>
          </el-form-item>
        </el-form>
      </template>
    </vxe-modal>
  </div>
</template>

<script lang="ts" setup>
import { onMounted, reactive, ref } from 'vue'
import { deleteFactorys, getFactoryList, modifyFactory, saveFactory } from '@/api/configure/factory'
import { ElMessage } from 'element-plus'
import type { VxeTableInstance } from 'vxe-table'

const loading = ref(false)
const saveLoading = ref(false)
const showEdit = ref(false)
const formState = reactive({
  factoryName: '',
  factoryCode: '',
  currentPage: 1,
  pageSize: 10,
  total: 0
})

const formRef = ref()
const xTable = ref<VxeTableInstance>()
const formRules = reactive({
  factoryName: [{ required: true, message: '请输入工厂名称', trigger: 'change' }],
  factoryCode: [{ required: true, message: '请输入工厂编码', trigger: 'change' }]
})
const formEdit = reactive({
  factoryName: '',
  factoryCode: '',
  factoryId: null
})

const tableData = ref([])
const onHide = () => {
  // 重置表单
  Object.assign(formEdit, {
    factoryName: '',
    factoryCode: '',
    factoryId: null
  })
}

const onReset = () => {}

const editRow = (row) => {
  Object.assign(formEdit, row)
  showEdit.value = true
}

const removeRows = async () => {
  const list = xTable.value?.getCheckboxRecords()
  if (list?.length) {
    const ids = list.map((item) => item.factoryId).join(',')
    await deleteFactorys(ids)
    ElMessage.success('删除成功！')
    onQuery()
  }
}

// 表单提交
const onSubmit = async () => {
  await formRef.value.validate()
  saveLoading.value = true
  try {
    formEdit.factoryId ? await modifyFactory(formEdit) : await saveFactory(formEdit)
    ElMessage.success('操作成功！')
    showEdit.value = false
    onQuery()
  } catch {}
  saveLoading.value = false
}

const onQuery = async () => {
  loading.value = true
  try {
    const { data } = await getFactoryList(formState)
    tableData.value = data.result.records
    formState.total = +data.result.total
  } catch {}
  loading.value = false
}

onMounted(() => {
  onQuery()
})
</script>
<style lang="scss" scoped></style>
